<template>
    <div>
        <div id="game">
            <GunUI/>
            <PlayerHpBar/>
            <WinGameOver
                v-model="dialog_game"
                :items="items"
                @close="gameClose"
            />
        </div>
        <!-- <div id="game_ui">
            
        </div> -->
    </div> 
    
</template>

<script>
import PlayerHpBar from "./PlayerHpBar";
import GunUI from "./GunUI";
import WinGameOver from "../components/WinGameOver";
import Phaser from "../phaser.min";
import LoadScene from "../phaser/scenes/LoadScene";
import GameScene from "../phaser/scenes/GameScene";
import {SocketGameEvents} from '../events/socket/game';

export default {
    components: {
        GunUI,
        PlayerHpBar,
        WinGameOver
    },
    mounted(){
        console.log('должен вставить игру!!!!');
        SocketGameEvents(this.$socket);
        // this.$store.commit('game/init', {
        //     time:0,
        //     status:'is_battle',
        //     player:{
        //         x:100,
        //         y:100,
        //         angle:0,
        //         tower_angle:0 
        //     },
        //     enemys:[]
        // });
        //this.createGame();
    },
    beforeDestroy(){
        this.game.destroy();
        this.game = null;
    },
    data: () => ({
        config:{
            type: Phaser.CANVAS,
            width: 800, 
            height: 600,
            parent: 'game',
            scale: {
                mode: Phaser.Scale.NONE,
            },
            fps:{
                min:10,
                target:60,
                forceSetTimeOut:false
            },
            render:{
                powerPreference:'high-performance'
            },
            scene: [LoadScene,GameScene]
        },
        game:null,
        dialog_game:false,
        items:[]
    }),
    computed:{

        status(){
            if(this.$store.state.game.game){
                return this.$store.state.game.game.status;
            }
        }
        // is_ready(){
        //     if(this.$store.state.game.game){
        //         return this.$store.state.game.game.status;
        //     }
        // },

        // is_gameOver(){
        //     if(this.$store.state.game.game){
        //         return this.$store.state.game.game.status;
        //     }
        // }
    },
    watch:{
        status:'whathStatus'
        // is_ready:'createGame',
        // is_gameOver:'gameOver'
    },
    methods:{
        whathStatus(){
            if(this.status){
                console.log('статус поменялся!!');
                if(!this.game){
                    this.createGame();
                }
                if(this.status==='game_over'){
                    this.gameOver();
                }
                if(this.status==='battle'){
                    if(this.$store.state.game.is_gameScene){
                        const gameScene = this.game.scene.getScene('GameScene');
                        //console.log('whathStatus.game = ', gameScene);
                        gameScene.forceBattle();
                    }
                    //const gameScene = this.game.scenes.get('GameScene');
                    
                }
            }
        },
        createGame(){
            this.game = new Phaser.Game(this.config);
        },
        gameOver(){
            setTimeout(()=>{
                this.items = this.$store.state.game.game.lader_board;
                //console.log('items = ', this.items);
                this.dialog_game = true;
                    //this.game.scene.shutdown();
                    //this.$store.commit('game/updateGame', {status:'battle'});
                    //this.game.scene.start("GameScene");
                    
            }, 600);
                //console.log('должен остановить сцену');
        },
        gameClose(){
            console.log(this.game);
            this.game.scene.keys['GameScene'].del();
        }
    }
};
</script>

<style scoped>
    #game{
        position: relative;
    }
</style>